﻿using Infragistics.Graphics;
using Infragistics.Portable.Components.Data;
using Infragistics.Win.DataVisualization;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace UltraDataChartMarkerTemplateDemo
{
    public partial class Form1 : Form
    {
        ViewModel vm = new ViewModel();
        CategoryXAxis xAxis; 
        NumericYAxis yAxis; 
        public Form1()
        {
            InitializeComponent();
            
            xAxis = new CategoryXAxis() { DataSource = vm.Data, Label = "Label" };
            yAxis = new NumericYAxis() { MinimumValue = 0, MaximumValue = 30 };

            LineSeries series = new LineSeries() { XAxis = xAxis, YAxis = yAxis, DataSource = vm.Data, ValueMemberPath = "Value" };

            CustomRenderTemplate template = new CustomRenderTemplate();
            template.Render = new DataTemplateRenderHandler(TemplateRender);
            template.Measure = new DataTemplateMeasureHandler(TemplateMeasure);
            

            series.MarkerType = MarkerType.Unset;
            series.MarkerTemplate = template;

            ultraDataChart1.Axes.Add(xAxis);
            ultraDataChart1.Axes.Add(yAxis);
            ultraDataChart1.Series.Add(series);
        }


        public void TemplateMeasure(DataTemplateMeasureInfo info)
        {
            info.Height = 12;
            info.Width = 12;
        }

        public void TemplateRender(DataTemplateRenderInfo info)
        {
            System.Drawing.Graphics graphics = info.Context as System.Drawing.Graphics;

            SampleData sd = info.Data.GetType().GetProperty("Item").GetValue(info.Data) as SampleData;

            if (graphics != null && (sd.Index == 3 || sd.Index == 10))
            {        
                graphics.FillRectangle(Brushes.Blue, new RectangleF((int)info.XPosition - 6, (int)info.YPosition - 6, 12, 12));
            }
        }
    }
}
